Index: trunk/source/tracking/src/G4SteppingManager2.cc
===================================================================
--- trunk/source/tracking/src/G4SteppingManager2.cc	(revision 1227)
+++ trunk/source/tracking/src/G4SteppingManager2.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4SteppingManager2.cc,v 1.37 2009/09/25 00:23:41 gum Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //---------------------------------------------------------------
Index: trunk/source/tracking/src/G4SteppingVerbose.cc
===================================================================
--- trunk/source/tracking/src/G4SteppingVerbose.cc	(revision 1227)
+++ trunk/source/tracking/src/G4SteppingVerbose.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4SteppingVerbose.cc,v 1.23 2006/07/14 14:13:57 tsasaki Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //---------------------------------------------------------------
Index: trunk/source/tracking/src/G4TrackingManager.cc
===================================================================
--- trunk/source/tracking/src/G4TrackingManager.cc	(revision 1227)
+++ trunk/source/tracking/src/G4TrackingManager.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4TrackingManager.cc,v 1.22 2006/11/14 10:58:47 tsasaki Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //---------------------------------------------------------------
Index: trunk/source/tracking/src/G4TrackingMessenger.cc
===================================================================
--- trunk/source/tracking/src/G4TrackingMessenger.cc	(revision 1227)
+++ trunk/source/tracking/src/G4TrackingMessenger.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4TrackingMessenger.cc,v 1.15 2006/11/03 11:13:38 allison Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //---------------------------------------------------------------
Index: trunk/source/tracking/src/G4Trajectory.cc
===================================================================
--- trunk/source/tracking/src/G4Trajectory.cc	(revision 1227)
+++ trunk/source/tracking/src/G4Trajectory.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4Trajectory.cc,v 1.33 2009/11/12 09:09:56 allison Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // ---------------------------------------------------------------
Index: trunk/source/tracking/src/G4TrajectoryPoint.cc
===================================================================
--- trunk/source/tracking/src/G4TrajectoryPoint.cc	(revision 1227)
+++ trunk/source/tracking/src/G4TrajectoryPoint.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4TrajectoryPoint.cc,v 1.19 2006/06/29 21:16:15 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // ---------------------------------------------------------------
Index: trunk/source/tracking/src/G4UserSteppingAction.cc
===================================================================
--- trunk/source/tracking/src/G4UserSteppingAction.cc	(revision 1227)
+++ trunk/source/tracking/src/G4UserSteppingAction.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4UserSteppingAction.cc,v 1.10 2006/06/29 21:16:17 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // ---------------------------------------------------------------
Index: trunk/source/tracking/src/G4UserTrackingAction.cc
===================================================================
--- trunk/source/tracking/src/G4UserTrackingAction.cc	(revision 1227)
+++ trunk/source/tracking/src/G4UserTrackingAction.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4UserTrackingAction.cc,v 1.10 2006/06/29 21:16:19 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // ---------------------------------------------------------------
Index: trunk/source/tracking/src/G4VSteppingVerbose.cc
===================================================================
--- trunk/source/tracking/src/G4VSteppingVerbose.cc	(revision 1227)
+++ trunk/source/tracking/src/G4VSteppingVerbose.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4VSteppingVerbose.cc,v 1.18 2006/11/14 10:58:47 tsasaki Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //---------------------------------------------------------------
Index: trunk/source/tracking/src/G4VTrajectory.cc
===================================================================
--- trunk/source/tracking/src/G4VTrajectory.cc	(revision 1227)
+++ trunk/source/tracking/src/G4VTrajectory.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4VTrajectory.cc,v 1.12 2006/10/16 13:45:01 allison Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // ---------------------------------------------------------------
Index: trunk/source/tracking/src/G4VTrajectoryPoint.cc
===================================================================
--- trunk/source/tracking/src/G4VTrajectoryPoint.cc	(revision 1227)
+++ trunk/source/tracking/src/G4VTrajectoryPoint.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4VTrajectoryPoint.cc,v 1.4 2006/06/29 21:16:26 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //---------------------------------------------------------------
Index: trunk/source/visualization/GNUmakefile
===================================================================
--- trunk/source/visualization/GNUmakefile	(revision 1227)
+++ trunk/source/visualization/GNUmakefile	(revision 1228)
@@ -1,3 +1,3 @@
-# $Id: GNUmakefile,v 1.24 2009/10/12 10:28:38 akimura Exp $
+# $Id: GNUmakefile,v 1.26 2009/11/17 11:31:20 gcosmo Exp $
 # -----------------------------------------------------------------------
 # GNUmakefile for visualization and modeling.  John Allison, 5/7/95.
@@ -30,6 +30,6 @@
 # CPPFLAGS += -DG4DEBUG_VIS_MANAGEMENT
 
-# Libraries which can be used without external packages or libraries...
 ifdef G4VIS_BUILD
+# Drivers that can be used without external libraries...
   SUBDIRS += management
   SUBLIBS += G4vis_management
@@ -48,9 +48,10 @@
   SUBDIRS += gMocren
   SUBLIBS += G4GMocren
-
+# Drivers needing external libraries...
 ifdef G4VIS_BUILD_OPENGL_DRIVER
   SUBDIRS += externals/gl2ps
   SUBDIRS += OpenGL
   SUBLIBS += G4OpenGL
+  SUBLIBS += G4gl2ps
 endif
 ifdef G4VIS_BUILD_OI_DRIVER
@@ -58,4 +59,5 @@
   SUBDIRS += OpenInventor
   SUBLIBS += G4OpenInventor
+  SUBLIBS += G4gl2ps
 endif
 endif #G4VIS_BUILD
Index: trunk/source/visualization/HepRep/History
===================================================================
--- trunk/source/visualization/HepRep/History	(revision 1227)
+++ trunk/source/visualization/HepRep/History	(revision 1228)
@@ -1,3 +1,3 @@
-.$Id: History,v 1.131 2009/10/21 15:13:36 allison Exp $
+.$Id: History,v 1.132 2009/11/23 05:42:28 perl Exp $
 -------------------------------------------------------------------
 
@@ -20,4 +20,9 @@
 History file for visualization/HepRep sub-category
 --------------------------------------------------
+
+22nd November 2009  Joseph Perl  (vis-HepRep-V09-02-03)
+- Changed messenger to a singleton.
+- Added messenger commands to HepRepFile.
+- Render G4Tubs as polygons if G4Tubs is not at a standard angle.
 
 21st October 2009  John Allison  (vis-HepRep-V09-02-02 coworks greps-V09-02-02)
Index: trunk/source/visualization/HepRep/include/G4HepRep.hh
===================================================================
--- trunk/source/visualization/HepRep/include/G4HepRep.hh	(revision 1227)
+++ trunk/source/visualization/HepRep/include/G4HepRep.hh	(revision 1228)
@@ -24,5 +24,5 @@
 // ********************************************************************
 //
-// $Id: G4HepRep.hh,v 1.17 2006/06/29 21:17:04 gunter Exp $
+// $Id: G4HepRep.hh,v 1.18 2009/11/23 05:42:28 perl Exp $
 // GEANT4 tag $Name:  $
 //
@@ -36,6 +36,4 @@
 //G4
 #include "G4VGraphicsSystem.hh"
-
-class G4HepRepMessenger;
 
 class G4HepRep: public G4VGraphicsSystem {
@@ -52,5 +50,4 @@
         G4VSceneHandler* sceneHandler;
         G4VViewer* viewer;
-        G4HepRepMessenger* messenger;        
 };
 
Index: trunk/source/visualization/HepRep/include/G4HepRepMessenger.hh
===================================================================
--- trunk/source/visualization/HepRep/include/G4HepRepMessenger.hh	(revision 1227)
+++ trunk/source/visualization/HepRep/include/G4HepRepMessenger.hh	(revision 1228)
@@ -24,5 +24,5 @@
 // ********************************************************************
 //
-// $Id: G4HepRepMessenger.hh,v 1.7 2006/06/29 21:17:14 gunter Exp $
+// $Id: G4HepRepMessenger.hh,v 1.8 2009/11/23 05:42:28 perl Exp $
 // GEANT4 tag $Name:  $
 //
@@ -40,5 +40,5 @@
     
     public:
-        G4HepRepMessenger();
+		static G4HepRepMessenger* GetInstance();  // Singleton constructor.
         virtual ~G4HepRepMessenger();
 
@@ -46,4 +46,11 @@
         virtual void SetNewValue(G4UIcommand * command, G4String newValue);
         
+	// Used by HepRepFile
+        virtual G4String getFileDir();
+        virtual G4String getFileName();
+        virtual G4bool getOverwrite();
+        virtual G4bool getCullInvisibles();
+	
+	// Used by HepRepXML
         virtual G4String getEventNumberSuffix();
         virtual G4bool appendGeometry();
@@ -53,5 +60,20 @@
 
     private:            
+		G4HepRepMessenger();  // Private constructor.
+		static G4HepRepMessenger* fpInstance;
+        
         G4UIdirectory* heprepDirectory;
+        
+		G4String fileDir;
+		G4UIcmdWithAString* setFileDirCommand;
+        
+		G4String fileName;
+		G4UIcmdWithAString* setFileNameCommand;
+        
+		G4bool overwrite;
+		G4UIcmdWithABool* setOverwriteCommand;
+        
+		G4bool cullInvisibles;
+		G4UIcmdWithABool* setCullInvisiblesCommand;
         
         G4String suffix;
@@ -66,5 +88,5 @@
         G4bool solids;
         G4UIcmdWithABool* useSolidsCommand;
-
+        
         G4bool invisibles;
         G4UIcmdWithABool* writeInvisiblesCommand;
Index: trunk/source/visualization/HepRep/include/G4HepRepSceneHandler.hh
===================================================================
--- trunk/source/visualization/HepRep/include/G4HepRepSceneHandler.hh	(revision 1227)
+++ trunk/source/visualization/HepRep/include/G4HepRepSceneHandler.hh	(revision 1228)
@@ -24,5 +24,5 @@
 // ********************************************************************
 //
-// $Id: G4HepRepSceneHandler.hh,v 1.43 2009/10/21 15:08:35 allison Exp $
+// $Id: G4HepRepSceneHandler.hh,v 1.44 2009/11/23 05:42:28 perl Exp $
 // GEANT4 tag $Name:  $
 //
@@ -63,10 +63,8 @@
 #include "G4PhysicalVolumeModel.hh"
 
-#include "G4HepRepMessenger.hh"
-
 class G4HepRepSceneHandler: public G4VSceneHandler {
 
     public:
-        G4HepRepSceneHandler (G4VGraphicsSystem& system, G4HepRepMessenger& messenger, const G4String& name = "");
+        G4HepRepSceneHandler (G4VGraphicsSystem& system, const G4String& name = "");
         virtual ~G4HepRepSceneHandler ();
 
@@ -187,5 +185,4 @@
 
         // initialized Member Variables
-        G4HepRepMessenger& messenger;
         G4String geometryLayer, eventLayer, calHitLayer;
         G4String trajectoryLayer, hitLayer;
Index: trunk/source/visualization/HepRep/include/G4HepRepViewer.hh
===================================================================
--- trunk/source/visualization/HepRep/include/G4HepRepViewer.hh	(revision 1227)
+++ trunk/source/visualization/HepRep/include/G4HepRepViewer.hh	(revision 1228)
@@ -24,5 +24,5 @@
 // ********************************************************************
 //
-// $Id: G4HepRepViewer.hh,v 1.18 2006/06/29 21:17:18 gunter Exp $
+// $Id: G4HepRepViewer.hh,v 1.19 2009/11/23 05:42:28 perl Exp $
 // GEANT4 tag $Name:  $
 //
@@ -41,9 +41,7 @@
 #include "G4VViewer.hh"
 
-#include "G4HepRepMessenger.hh"
-
 class G4HepRepViewer: public G4VViewer {
     public:
-        G4HepRepViewer (G4VSceneHandler& scene, G4HepRepMessenger& messenger, const G4String& name = "");
+        G4HepRepViewer (G4VSceneHandler& scene, const G4String& name = "");
         virtual ~G4HepRepViewer ();
         void SetView ();
@@ -57,5 +55,4 @@
     private:
         bool geometryIncluded;
-        G4HepRepMessenger& messenger;
 };
 
Index: trunk/source/visualization/HepRep/src/G4HepRep.cc
===================================================================
--- trunk/source/visualization/HepRep/src/G4HepRep.cc	(revision 1227)
+++ trunk/source/visualization/HepRep/src/G4HepRep.cc	(revision 1228)
@@ -24,5 +24,5 @@
 // ********************************************************************
 //
-// $Id: G4HepRep.cc,v 1.22 2006/06/29 21:17:20 gunter Exp $
+// $Id: G4HepRep.cc,v 1.23 2009/11/23 05:42:28 perl Exp $
 // GEANT4 tag $Name:  $
 //
@@ -54,9 +54,8 @@
           sceneHandler(NULL),
           viewer(NULL) {
-    messenger = new G4HepRepMessenger();
+		G4HepRepMessenger::GetInstance();
 }
 
 G4HepRep::~G4HepRep () {
-    delete messenger;
 }
 
@@ -66,5 +65,5 @@
         return NULL;
     }
-    sceneHandler = new G4HepRepSceneHandler (*this, *messenger, name);
+    sceneHandler = new G4HepRepSceneHandler (*this, name);
     return sceneHandler;
 }
@@ -75,5 +74,5 @@
         return NULL;
     }
-    viewer  = new G4HepRepViewer ((G4HepRepSceneHandler&)scene, *messenger, name);
+    viewer  = new G4HepRepViewer ((G4HepRepSceneHandler&)scene, name);
     return viewer;
 }
Index: trunk/source/visualization/HepRep/src/G4HepRepFile.cc
===================================================================
--- trunk/source/visualization/HepRep/src/G4HepRepFile.cc	(revision 1227)
+++ trunk/source/visualization/HepRep/src/G4HepRepFile.cc	(revision 1228)
@@ -24,5 +24,5 @@
 // ********************************************************************
 //
-// $Id: G4HepRepFile.cc,v 1.11 2007/05/22 17:05:26 allison Exp $
+// $Id: G4HepRepFile.cc,v 1.12 2009/11/23 05:42:28 perl Exp $
 // GEANT4 tag $Name:  $
 //
@@ -38,4 +38,5 @@
 #include "G4HepRepFileSceneHandler.hh"
 #include "G4HepRepFileViewer.hh"
+#include "G4HepRepMessenger.hh"
 
 static G4HepRepFileXMLWriter* hepRepXMLWriter;
@@ -46,4 +47,5 @@
 		    "A HepRep (format 1) ascii file driver",
 		    G4VGraphicsSystem::threeD) {
+		G4HepRepMessenger::GetInstance();
         hepRepXMLWriter = new G4HepRepFileXMLWriter();
 }
Index: trunk/source/visualization/HepRep/src/G4HepRepFileSceneHandler.cc
===================================================================
--- trunk/source/visualization/HepRep/src/G4HepRepFileSceneHandler.cc	(revision 1227)
+++ trunk/source/visualization/HepRep/src/G4HepRepFileSceneHandler.cc	(revision 1228)
@@ -24,5 +24,5 @@
 // ********************************************************************
 //
-// $Id: G4HepRepFileSceneHandler.cc,v 1.66 2008/01/04 22:11:31 allison Exp $
+// $Id: G4HepRepFileSceneHandler.cc,v 1.68 2009/12/16 17:51:21 gunter Exp $
 // GEANT4 tag $Name:  $
 //
@@ -34,4 +34,6 @@
 #include "G4HepRepFileSceneHandler.hh"
 #include "G4HepRepFile.hh"
+#include "G4HepRepMessenger.hh"
+#include "G4UIcommand.hh"
 
 #include "G4Version.hh"
@@ -71,25 +73,4 @@
 	hepRepXMLWriter = ((G4HepRepFile*)(&system))->GetHepRepXMLWriter();
 	fileCounter = 0;
-	int length;
-	
-	if (getenv("G4HEPREPFILE_DIR") == NULL)
-		strcpy(fileDir, "");
-	else
-		length = sprintf (fileDir, "%s%s", getenv("G4HEPREPFILE_DIR"),"/");
-	
-	if (getenv("G4HEPREPFILE_NAME") == NULL)
-		strcpy(fileName, "G4Data");
-	else
-		strcpy(fileName, getenv("G4HEPREPFILE_NAME"));
-	
-	if (getenv("G4HEPREPFILE_OVERWRITE") == NULL)
-		fileOverwrite = false;
-	else
-		fileOverwrite = strcmp(getenv("G4HEPREPFILE_OVERWRITE"),"0");
-	
-	if (getenv("G4HEPREPFILE_CULL") == NULL)
-		cullInvisibleObjects = false;
-	else
-		cullInvisibleObjects = strcmp(getenv("G4HEPREPFILE_CULL"),"0");
 	
 	inPrimitives2D = false;
@@ -180,5 +161,7 @@
 	AddHepRepInstance("Prism", NULL);
 	
-	if (fpVisAttribs && (fpVisAttribs->IsVisible()==0) && cullInvisibleObjects)
+	G4HepRepMessenger* messenger = G4HepRepMessenger::GetInstance();
+	
+	if (fpVisAttribs && (fpVisAttribs->IsVisible()==0) && messenger->getCullInvisibles())
 		return;
 	
@@ -243,5 +226,7 @@
 		AddHepRepInstance("Cylinder", NULL);
 		
-		if (fpVisAttribs && (fpVisAttribs->IsVisible()==0) && cullInvisibleObjects)
+		G4HepRepMessenger* messenger = G4HepRepMessenger::GetInstance();
+		
+		if (fpVisAttribs && (fpVisAttribs->IsVisible()==0) && messenger->getCullInvisibles())
 			return;
 		
@@ -278,8 +263,21 @@
 #endif
 	
+	// HepRApp does not correctly represent the end faces of cylinders at
+	// non-standard angles, let the base class convert these solids to polygons.	
+	CLHEP::HepRotation r = fpObjectTransformation->getRotation();	
+	G4bool linedUpWithAnAxis = (std::fabs(r.phiX())<=.001 ||  
+								std::fabs(r.phiY())<=.001 || 
+								std::fabs(r.phiZ())<=.001 ||
+								std::fabs(r.phiX()-pi)<=.001 ||
+								std::fabs(r.phiY()-pi)<=.001 ||
+								std::fabs(r.phiZ()-pi)<=.001);	
+	//G4cout << "Angle X:" << r.phiX() << ", Angle Y:" << r.phiY() << ", Angle Z:" << r.phiZ() << G4endl;
+	//G4cout << "linedUpWithAnAxis:" << linedUpWithAnAxis << G4endl;
+	
 	// HepRep does not have a primitive for a cut cylinder,
 	// so if this cylinder is cut, let the base class convert this
 	// solid to polygons.
-	if (tubs.GetDeltaPhiAngle() < twopi) {
+	if (tubs.GetDeltaPhiAngle() < twopi || !linedUpWithAnAxis)
+	{
 		G4VSceneHandler::AddSolid(tubs);  // Invoke default action.
 	} else {
@@ -294,5 +292,7 @@
 		AddHepRepInstance("Cylinder", NULL);
 		
-		if (fpVisAttribs && (fpVisAttribs->IsVisible()==0) && cullInvisibleObjects)
+		G4HepRepMessenger* messenger = G4HepRepMessenger::GetInstance();
+		
+		if (fpVisAttribs && (fpVisAttribs->IsVisible()==0) && messenger->getCullInvisibles())
 			return;
 		
@@ -340,5 +340,7 @@
 	AddHepRepInstance("Prism", NULL);
 	
-	if (fpVisAttribs && (fpVisAttribs->IsVisible()==0) && cullInvisibleObjects)
+	G4HepRepMessenger* messenger = G4HepRepMessenger::GetInstance();
+	
+	if (fpVisAttribs && (fpVisAttribs->IsVisible()==0) && messenger->getCullInvisibles())
 		return;
 	
@@ -1004,5 +1006,7 @@
 #endif
 	
-	if (fpVisAttribs && (fpVisAttribs->IsVisible()==0) && cullInvisibleObjects)
+	G4HepRepMessenger* messenger = G4HepRepMessenger::GetInstance();
+	
+	if (fpVisAttribs && (fpVisAttribs->IsVisible()==0) && messenger->getCullInvisibles())
 		return;
 	
@@ -1042,5 +1046,7 @@
 #endif
 	
-	if (fpVisAttribs && (fpVisAttribs->IsVisible()==0) && cullInvisibleObjects)
+	G4HepRepMessenger* messenger = G4HepRepMessenger::GetInstance();
+	
+	if (fpVisAttribs && (fpVisAttribs->IsVisible()==0) && messenger->getCullInvisibles())
 		return;
 	
@@ -1144,5 +1150,7 @@
 #endif
 	
-	if (fpVisAttribs && (fpVisAttribs->IsVisible()==0) && cullInvisibleObjects)
+	G4HepRepMessenger* messenger = G4HepRepMessenger::GetInstance();
+	
+	if (fpVisAttribs && (fpVisAttribs->IsVisible()==0) && messenger->getCullInvisibles())
 		return;
 	
@@ -1188,5 +1196,7 @@
 #endif
 	
-	if (fpVisAttribs && (fpVisAttribs->IsVisible()==0) && cullInvisibleObjects)
+	G4HepRepMessenger* messenger = G4HepRepMessenger::GetInstance();
+	
+	if (fpVisAttribs && (fpVisAttribs->IsVisible()==0) && messenger->getCullInvisibles())
 		return;
 	
@@ -1231,5 +1241,7 @@
 #endif
 	
-	if (fpVisAttribs && (fpVisAttribs->IsVisible()==0) && cullInvisibleObjects)
+	G4HepRepMessenger* messenger = G4HepRepMessenger::GetInstance();
+	
+	if (fpVisAttribs && (fpVisAttribs->IsVisible()==0) && messenger->getCullInvisibles())
 		return;
 	
@@ -1430,5 +1442,7 @@
 		hepRepXMLWriter->addInstance();
 		
-		if (fpVisAttribs && (fpVisAttribs->IsVisible()==0) && cullInvisibleObjects)
+		G4HepRepMessenger* messenger = G4HepRepMessenger::GetInstance();
+		
+		if (fpVisAttribs && (fpVisAttribs->IsVisible()==0) && messenger->getCullInvisibles())
 			return;
 		
@@ -1512,16 +1526,20 @@
 	
 	if (!hepRepXMLWriter->isOpen) {
-		char* newFileSpec;
-		newFileSpec = new char [256];
-		int length;
-		
-		if (fileOverwrite)
-			length = sprintf (newFileSpec, "%s%s%s",fileDir,fileName,".heprep");
-		else
-			length = sprintf (newFileSpec, "%s%s%d%s",fileDir,fileName,fileCounter,".heprep");
+		G4String newFileSpec;
+
+		G4HepRepMessenger* messenger = G4HepRepMessenger::GetInstance();
+		
+		if (messenger->getOverwrite()) {
+			newFileSpec = messenger->getFileDir()+messenger->getFileName()+".heprep";
+		} else {
+			newFileSpec = messenger->getFileDir()+messenger->getFileName()+G4UIcommand::ConvertToString(fileCounter)+".heprep";
+		}
+		
 		G4cout << "HepRepFile writing to " << newFileSpec << G4endl;
 		
 		hepRepXMLWriter->open(newFileSpec);
-		fileCounter++;
+		
+		if (!messenger->getOverwrite())
+			fileCounter++;
 		
 		hepRepXMLWriter->addAttDef("Generator", "HepRep Data Generator", "Physics","");
Index: trunk/source/visualization/HepRep/src/G4HepRepMessenger.cc
===================================================================
--- trunk/source/visualization/HepRep/src/G4HepRepMessenger.cc	(revision 1227)
+++ trunk/source/visualization/HepRep/src/G4HepRepMessenger.cc	(revision 1228)
@@ -24,10 +24,24 @@
 // ********************************************************************
 //
-// $Id: G4HepRepMessenger.cc,v 1.10 2006/06/29 21:17:30 gunter Exp $
+// $Id: G4HepRepMessenger.cc,v 1.11 2009/11/23 05:42:28 perl Exp $
 // GEANT4 tag $Name:  $
 //
 #include "G4HepRepMessenger.hh"
 
+G4HepRepMessenger*
+G4HepRepMessenger::fpInstance = 0;
+
+G4HepRepMessenger*
+G4HepRepMessenger::GetInstance()
+{
+	if (!fpInstance) fpInstance = new G4HepRepMessenger;
+	return fpInstance;
+}
+
 G4HepRepMessenger::G4HepRepMessenger() :
+    fileDir(""),
+	fileName("G4Data"),
+	overwrite(false),
+	cullInvisibles(false),
     suffix (""),
     geometry(true),
@@ -37,8 +51,58 @@
     heprepDirectory = new G4UIdirectory("/vis/heprep/");
     heprepDirectory->SetGuidance("HepRep commands.");
-
+		
+	setFileDirCommand = new G4UIcmdWithAString("/vis/heprep/setFileDir", this);
+	setFileDirCommand->SetGuidance("Set directory for output.");
+	setFileDirCommand->SetGuidance("This command is used by HepRepFile, not by HepRepXML.");
+	setFileDirCommand->SetParameterName("directory",false);
+	if ( getenv( "G4HEPREPFILE_DIR" ) == NULL ) {
+		setFileDirCommand->SetDefaultValue("");
+	} else {
+		setFileDirCommand->SetDefaultValue(getenv("G4HEPREPFILE_DIR"));
+		fileDir = getenv("G4HEPREPFILE_DIR");
+	}
+	setFileDirCommand->AvailableForStates(G4State_Idle);
+		
+	setFileNameCommand = new G4UIcmdWithAString("/vis/heprep/setFileName", this);
+	setFileNameCommand->SetGuidance("Set file name for output.");
+	setFileNameCommand->SetGuidance("This command is used by HepRepFile, not by HepRepXML.");
+	setFileNameCommand->SetParameterName("directory",false);
+	if ( getenv( "G4HEPREPFILE_NAME" ) == NULL ) {
+		setFileNameCommand->SetDefaultValue("G4Data");
+	} else {
+		setFileNameCommand->SetDefaultValue(getenv("G4HEPREPFILE_NAME"));
+		fileName = getenv("G4HEPREPFILE_NAME");
+	}
+	setFileNameCommand->AvailableForStates(G4State_Idle);
+
+	setOverwriteCommand = new G4UIcmdWithABool("/vis/heprep/setOverwrite", this);
+	setOverwriteCommand->SetGuidance("Set true to write all output to exact same file name.");
+	setOverwriteCommand->SetGuidance("Set false to increment the file name for each new output.");
+	setOverwriteCommand->SetGuidance("This command is used by HepRepFile, not by HepRepXML.");
+	setOverwriteCommand->SetParameterName("flag",false);
+	if ( getenv( "G4HEPREPFILE_OVERWRITE" ) == NULL ) {
+		setOverwriteCommand->SetDefaultValue(false);
+	} else {
+		setOverwriteCommand->SetDefaultValue(getenv("G4HEPREPFILE_OVERWRITE"));
+		overwrite = setOverwriteCommand->ConvertToBool(getenv("G4HEPREPFILE_OVERWRITE"));
+	}
+	setOverwriteCommand->AvailableForStates(G4State_Idle);
+		
+	setCullInvisiblesCommand = new G4UIcmdWithABool("/vis/heprep/setCullInvisibles", this);
+	setCullInvisiblesCommand->SetGuidance("Remove invisible objects from output file.");
+	setCullInvisiblesCommand->SetGuidance("This command is used by HepRepFile, not by HepRepXML.");
+	setCullInvisiblesCommand->SetParameterName("flag",false);
+	if ( getenv( "G4HEPREPFILE_CULL" ) == NULL ) {
+		setCullInvisiblesCommand->SetDefaultValue(false);
+	} else {
+		setCullInvisiblesCommand->SetDefaultValue(getenv("G4HEPREPFILE_CULL"));
+		cullInvisibles = setCullInvisiblesCommand->ConvertToBool(getenv("G4HEPREPFILE_CULL"));
+	}
+	setCullInvisiblesCommand->AvailableForStates(G4State_Idle);
+		
     setEventNumberSuffixCommand = new G4UIcmdWithAString("/vis/heprep/setEventNumberSuffix", this);
     setEventNumberSuffixCommand->SetGuidance("Write separate event files, appended with given suffix.");
     setEventNumberSuffixCommand->SetGuidance("Define the suffix with a pattern such as '-0000'.");
+	setEventNumberSuffixCommand->SetGuidance("This command is used by HepRepXML, not by HepRepFile.");
     setEventNumberSuffixCommand->SetParameterName("suffix",false);
     setEventNumberSuffixCommand->SetDefaultValue("");
@@ -47,4 +111,5 @@
     appendGeometryCommand = new G4UIcmdWithABool("/vis/heprep/appendGeometry", this);
     appendGeometryCommand->SetGuidance("Appends copy of geometry to every event.");
+	appendGeometryCommand->SetGuidance("This command is used by HepRepXML, not by HepRepFile.");
     appendGeometryCommand->SetParameterName("flag",false);
     appendGeometryCommand->SetDefaultValue(true);
@@ -53,4 +118,5 @@
     addPointAttributesCommand = new G4UIcmdWithABool("/vis/heprep/addPointAttributes", this);
     addPointAttributesCommand->SetGuidance("Adds point attributes to the points of trajectories.");
+	addPointAttributesCommand->SetGuidance("This command is used by HepRepXML, not by HepRepFile.");
     addPointAttributesCommand->SetParameterName("flag",false);
     addPointAttributesCommand->SetDefaultValue(false);
@@ -59,29 +125,33 @@
     useSolidsCommand = new G4UIcmdWithABool("/vis/heprep/useSolids", this);
     useSolidsCommand->SetGuidance("Use HepRep Solids, rather than Geant4 Primitives.");
+	useSolidsCommand->SetGuidance("This command is used by HepRepXML, not by HepRepFile.");
     useSolidsCommand->SetParameterName("flag",false);
     useSolidsCommand->SetDefaultValue(true);
     useSolidsCommand->AvailableForStates(G4State_Idle);
-
-/* Not Enabled Yet
-    writeInvisiblesCommand = new G4UIcmdWithABool("/vis/heprep/writeInvisibles", this);
-    writeInvisiblesCommand->SetGuidance("Write invisible objects.");
-    writeInvisiblesCommand->SetParameterName("flag",false);
-    writeInvisiblesCommand->SetDefaultValue(true);
-    writeInvisiblesCommand->AvailableForStates(G4State_Idle);
-*/
 }
 
 G4HepRepMessenger::~G4HepRepMessenger() {
+	delete setFileDirCommand;
+	delete setFileNameCommand;
+	delete setOverwriteCommand;
+	delete setCullInvisiblesCommand;
     delete setEventNumberSuffixCommand;
     delete appendGeometryCommand;
     delete addPointAttributesCommand;
     delete useSolidsCommand;
-//    delete writeInvisiblesCommand;
     delete heprepDirectory;
 }
 
 G4String G4HepRepMessenger::GetCurrentValue(G4UIcommand * command) {
-    if (command==setEventNumberSuffixCommand) {
-        return suffix;
+    if (command==setFileDirCommand) {
+        return fileDir;
+    } else if (command==setFileNameCommand) {
+        return fileName; 
+    } else if (command==setOverwriteCommand) {
+        return overwrite; 
+    } else if (command==setCullInvisiblesCommand) {
+        return cullInvisibles; 
+    } else if (command==setEventNumberSuffixCommand) {
+        return suffix; 
     } else if (command==appendGeometryCommand) {
         return appendGeometryCommand->ConvertToString(geometry); 
@@ -90,6 +160,4 @@
     } else if (command==useSolidsCommand) {
         return useSolidsCommand->ConvertToString(solids);
-//    } else if (command==writeInvisiblesCommand) {
-//        return writeInvisiblesCommand->ConvertToString(invisibles);
     } else {
         return "";
@@ -98,5 +166,13 @@
 
 void G4HepRepMessenger::SetNewValue(G4UIcommand * command, G4String newValue) {
-    if (command==setEventNumberSuffixCommand) {
+    if (command==setFileDirCommand) {
+        fileDir = newValue;
+    } else if (command==setFileNameCommand) {
+        fileName = newValue;
+    } else if (command==setOverwriteCommand) {
+        overwrite = setOverwriteCommand->GetNewBoolValue(newValue);
+    } else if (command==setCullInvisiblesCommand) {
+		cullInvisibles = setCullInvisiblesCommand->GetNewBoolValue(newValue);
+    } else if (command==setEventNumberSuffixCommand) {
         suffix = newValue;
     } else if (command==appendGeometryCommand) {
@@ -106,7 +182,21 @@
     } else if (command==useSolidsCommand) {
         solids = useSolidsCommand->GetNewBoolValue(newValue);
-//    } else if (command==writeInvisiblesCommand) {
-//        invisibles = writeInvisiblesCommand->GetNewBoolValue(newValue);
     } 
+}
+
+G4String G4HepRepMessenger::getFileDir() {
+    return fileDir;
+}
+
+G4String G4HepRepMessenger::getFileName() {
+    return fileName;
+}
+
+G4bool G4HepRepMessenger::getOverwrite() {
+    return overwrite;
+}
+
+G4bool G4HepRepMessenger::getCullInvisibles() {
+    return cullInvisibles;
 }
 
